#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#include <math.h>
#include <stdlib.h>
#include <gtkgl/gtkglarea.h>

int rotate_flag = 1;
float x_rot = 0.0;
float y_rot = 0.0;
float z_rot = 0.0;
float howfar = 0.0;
float howfar_init = 250.0;

float x_rot_temp = 0.0;
float y_rot_temp = 0.0;
float z_rot_temp = 0.0;
float howfar_temp = 0.0;

GLuint fontbase;

extern float ball_x;
extern float ball_y;

extern float one_pos;
extern float two_pos;

extern char player_names[2][20];

extern int one_points;
extern int two_points;

extern int player_won;




gint init(GtkWidget *widget)
{
  /* OpenGL functions can be called only if makecurrent returns true */
  if (gtk_gl_area_make_current(GTK_GL_AREA(widget))) {
    
    GdkFont *font;
    
    //GLfloat mat_specular[] = { 1.0, 1.0, 1.0, 1.0};
    //GLfloat mat_shininess[] = { 50.0 };
    //GLfloat lightposition[] = { 40.0 , 40.0, 40.0 , 0.0 };
    //GLfloat white_light[] = { 1.0, 1.0, 1.0, 1.0};
    
    /* set viewport */
    glViewport(0,0, widget->allocation.width, widget->allocation.height);
    
    
    glClearColor(0.0,0.0,0.0,0.0);
    //light stuff
    //glShadeModel(GL_SMOOTH);
    //glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular);
    //glMaterialfv(GL_FRONT, GL_SHININESS, mat_shininess);
    //glLightfv(GL_LIGHT0, GL_POSITION, lightposition);
    //glLightfv(GL_LIGHT0, GL_DIFFUSE, white_light);
    //glLightfv(GL_LIGHT0, GL_SPECULAR, white_light);
    //glEnable(GL_LIGHTING);
    //glEnable(GL_LIGHT0);
    //glEnable(GL_DEPTH_TEST);
    
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluPerspective(65.0,640.0/480.0,1.0,1000.0);
    gluLookAt(0.0,0.0,howfar_init,0.0,0.0,0.0,0.0,1.0,0.0);
    
    //glRotatef(-45.0,1.0,0.0,0.0);
    //glRotatef(45.0,1.0,1.0,1.0);
    //glOrtho(-160.0, 160.0, -100.0, 120.0, -100.0, 100.0);
    /*glortho: left, right, bottom, top, near, far*/  
    
    /*generate font display lists */
    font = gdk_font_load("-adobe-helvetica-medium-r-normal--*-120-*-*-*-*-*-*");
    if (font) {
      fontbase = glGenLists( 128 );
      gdk_gl_use_gdk_font(font, 0, 128, fontbase);
      gdk_font_unref(font);
    }
  }
  return TRUE;
}


/* When glarea widget size changes, viewport size is set to match the new size */
gint reshape(GtkWidget *widget, GdkEventConfigure *event)
{
  /* OpenGL functions can be called only if make_current returns true */
  if (gtk_gl_area_make_current(GTK_GL_AREA(widget)))
    {
      glViewport(0,0, widget->allocation.width, widget->allocation.height);
      
      
      
    }
  //possibly updteGL by calling draw()
  return TRUE;
}

gint game_render()
{
  GLUquadricObj *center_circle;
  GLUquadricObj *ball_circle,*ball_cyl;
  
  float rot_dx, rot_dy, rot_dz, dhowfar;
  rot_dx = x_rot - x_rot_temp;
  rot_dy = y_rot - y_rot_temp;
  rot_dz = z_rot - z_rot_temp;
  dhowfar = howfar - howfar_temp;

  if(rot_dx != 0 || rot_dy != 0 || rot_dz != 0){
    glRotatef(rot_dy,0.0,1.0,0.0);
    glRotatef(rot_dx,1.0,0.0,0.0);
    glRotatef(rot_dz,0.0,0.0,1.0);
  }
  if(dhowfar != 0){
    gluLookAt(0.0,0.0,dhowfar,0.0,0.0,0.0,0.0,1.0,0.0);
    g_print("%f\n",dhowfar);
  }
  x_rot_temp = x_rot;
  y_rot_temp = y_rot;
  z_rot_temp = z_rot;
  howfar_temp = howfar;
  /*do the green background*/
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  
  /*draw the soccer field outline*/
  glColor3f(0.2,0.8,0.1);
  glBegin(GL_POLYGON);
  glVertex3f(-180.0, -130.0, 0.0);
  glVertex3f(180.0,-130.0,0.0);
  glVertex3f(180.0,130.0,0.0);
  glVertex3f(-180.0,130.0,0.0);
  glEnd();
  glColor3f(1.0,1.0,1.0);
  //glLineWidth(1.0);
  glBegin(GL_LINE_LOOP);
  glVertex3f(-150.0,-90.0,0.0);
  glVertex3f(150.0,-90.0,0.0);
  glVertex3f(150.0,90.0,0.0);
  glVertex3f(-150.0,90.0,0.0);
  glEnd();
  glBegin(GL_LINES);
  glVertex3f(0.0,90.0,0.0);
  glVertex3f(0.0,-90.0,0.0);
  glEnd();
  
  /* central circumference */
  center_circle = gluNewQuadric();
  gluDisk(center_circle,50.0,50.5,40,2);
  
  /* ball*/
  ball_circle = gluNewQuadric();
  ball_cyl = gluNewQuadric();
  glPushMatrix();
  glTranslatef(ball_x,ball_y,0.0);
  glColor3f(0.0,0.0,0.0);
  gluCylinder(ball_cyl,6.0,6.0,4.0,40,2);  
  glTranslatef(0.0,0.0,4.0);
  gluDisk(ball_circle,6.0,0.1,40,2);
  //glPopMatrix();
  
  // glPushMatrix();
  
  
  
  //glutSolidSphere(30.0,20,16);
  glPopMatrix();
  
  /* draw the paddles */
  /* paddle 1 */
  glPushMatrix();
  glColor3f(1.0,0.0,0.0);
  glTranslatef(-150.0,one_pos,0.0);
  glBegin(GL_POLYGON);
  glVertex3f(0.0,16.0,0.0);
  glVertex3f(6.0,16.0,0.0);
  glColor3f(1.0,1.0,0.0);
  glVertex3f(6.0,-16.0,0.0);
  glVertex3f(0.0,-16.0,0.0);
  glEnd();
  
  glColor3f(1.0,0.0,0.0);
  glBegin(GL_POLYGON);
  glVertex3f(0.0,16.0,6.0);
  glVertex3f(6.0,16.0,6.0);
  glColor3f(1.0,1.0,0.0);
  glVertex3f(6.0,-16.0,6.0);
  glVertex3f(0.0,-16.0,6.0);
  glEnd();
  

  glColor3f(1.0,0.0,0.0);
  glBegin(GL_POLYGON);
  glVertex3f(0.0,16.0,0.0);
  glVertex3f(6.0,16.0,0.0);
  glVertex3f(0.0,16.0,6.0);
  glVertex3f(6.0,16.0,6.0);
  glEnd();

  glColor3f(1.0,1.0,0.0);
  glBegin(GL_POLYGON);
  glVertex3f(0.0,-16.0,0.0);
  glVertex3f(6.0,-16.0,0.0);
  glVertex3f(0.0,-16.0,6.0);
  glVertex3f(6.0,-16.0,6.0);
  glEnd();
  
  glColor3f(1.0,0.0,0.0);
  glBegin(GL_POLYGON);
  glVertex3f(0.0,16.0,0.0);
  glVertex3f(0.0,16.0,6.0);
  glColor3f(1.0,1.0,0.0);
  glVertex3f(0.0,-16.0,6.0);
  glVertex3f(0.0,-16.0,0.0);
  glEnd();

  glColor3f(1.0,0.0,0.0);
  glBegin(GL_POLYGON);
  glVertex3f(6.0,16.0,0.0);
  glVertex3f(6.0,16.0,6.0);
  glColor3f(1.0,1.0,0.0);
  glVertex3f(6.0,-16.0,6.0);
  glVertex3f(6.0,-16.0,0.0);
  glEnd();
  
  glPopMatrix();
  /* paddle 2 */
  glPushMatrix();
  glColor3f(0.0,0.0,1.0);
  glTranslatef(144.0,two_pos,0.0);
  glBegin(GL_POLYGON);
  glVertex3f(0.0,16.0,0.0);
  glVertex3f(6.0,16.0,0.0);
  glColor3f(0.0,1.0,1.0);
  glVertex3f(6.0,-16.0,0.0);
  glVertex3f(0.0,-16.0,0.0);
  glEnd();
  
  glColor3f(0.0,0.0,1.0);
  glBegin(GL_POLYGON);
  glVertex3f(0.0,16.0,6.0);
  glVertex3f(6.0,16.0,6.0);
  glColor3f(0.0,1.0,1.0);
  glVertex3f(6.0,-16.0,6.0);
  glVertex3f(0.0,-16.0,6.0);
  glEnd();
  
  glColor3f(0.0,0.0,1.0);
  glBegin(GL_POLYGON);
  glVertex3f(0.0,16.0,0.0);
  glVertex3f(6.0,16.0,0.0);
  glVertex3f(6.0,16.0,6.0);
  glVertex3f(0.0,16.0,6.0);
  glEnd();
  
  glColor3f(0.0,1.0,1.0);
  glBegin(GL_POLYGON);
  glVertex3f(0.0,-16.0,0.0);
  glVertex3f(6.0,-16.0,0.0);
  glVertex3f(6.0,-16.0,6.0);
  glVertex3f(0.0,-16.0,6.0);
  glEnd();
  
  glColor3f(0.0,0.0,1.0);
  glBegin(GL_POLYGON);
  glVertex3f(6.0,16.0,0.0);
  glVertex3f(6.0,16.0,6.0);
  glColor3f(0.0,1.0,1.0);
  glVertex3f(6.0,-16.0,6.0);
  glVertex3f(6.0,-16.0,0.0);
  glEnd();
  
  glColor3f(0.0,0.0,1.0);
  glBegin(GL_POLYGON);
  glVertex3f(0.0,16.0,0.0);
  glVertex3f(0.0,16.0,6.0);
  glColor3f(0.0,1.0,1.0);
  glVertex3f(0.0,-16.0,6.0);
  glVertex3f(0.0,-16.0,0.0);
  glEnd();
  
  glPopMatrix();
  
  /* textual info */
  if (fontbase) {
    char s[200];
    glColor3f(1.0,0.0,0.0);
    g_snprintf(s, sizeof(s), "%s: %d",player_names[0],one_points);
    glRasterPos2f(-150.0,100.0);
    glListBase(fontbase);
    glCallLists(strlen(s), GL_UNSIGNED_BYTE, s);
    glColor3f(0.4,0.0,1.0);
    g_snprintf(s, sizeof(s), "%s: %d",player_names[1],two_points);
    glRasterPos2f(110.0,100.0);
    glListBase(fontbase);
    glCallLists(strlen(s), GL_UNSIGNED_BYTE, s);
    if(player_won!=0){
      g_snprintf(s, sizeof(s), "Winner is %s",player_names[player_won - 1]);
      glRasterPos2f(-30.0,100.0);
      glListBase(fontbase);
      glCallLists(strlen(s), GL_UNSIGNED_BYTE, s);
    }
    
    //g_snprintf(s,sizeof(s),"%d",two_points);
  }
  
  gluDeleteQuadric(ball_circle);
  gluDeleteQuadric(ball_cyl);
  gluDeleteQuadric(center_circle);
  

  
  glFlush();
  
  

}


/* When widget is exposed it's contents are redrawn. */
 gint draw(GtkWidget *widget, GdkEventExpose *event)
{
  /* Draw only last expose. */
  if (event->count > 0)
    return TRUE;

  if (gtk_gl_area_make_current(GTK_GL_AREA(widget)))
    game_render();
  
  /* Swap backbuffer to front */
  gtk_gl_area_swapbuffers(GTK_GL_AREA(widget));
  
  return TRUE;
}

gint animate(GtkWidget *glarea)
{
  
  game_play();
  gtk_widget_draw(GTK_WIDGET(glarea), NULL);
  
  return TRUE;
}
