#ifdef SOUND_LINUX

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/soundcard.h>
#include <sys/ioctl.h>
#include <errno.h>
#include <gtk/gtk.h>
#include <stdio.h>
#include "sound.h"
#ifdef HAVE_CONFIG
#include "config.h"
#endif

int audio_fd;
gboolean sound_enabled;
char coll_snd[1025];
int coll_sndc;

void play_sound(char *sound, int count)
{
  if(!sound_enabled)
    {
      g_message("Sound not available.");
      return;
    }
  if(audio_fd < 0)
    {
      g_message("Sound device not open.");
      return;
    }
  if(write(audio_fd, sound, count) < 0)
    {
      g_message("Write to sound device failed.");
      return;
    }
  ioctl(audio_fd, SNDCTL_DSP_POST, 0);
}

int load_sound(char *file, char *buffer, int *count)
{
  int fd = open(file, O_RDONLY);
  *count = read(fd, buffer, *count);
  close(fd);
  return *count;
}

void open_sound_device(char *name)
{
  audio_fd = open(name, O_WRONLY);
  if(audio_fd < 0)
    fprintf(stderr,"Could not open sound\n");
}

void configure_sound_device()
{
  int fragment = 0x7fff0008;
  if( ioctl(audio_fd, SNDCTL_DSP_SETFRAGMENT, &fragment) < 0 )
    fprintf(stderr,"Sound card does not support appropriate fragment size");
  if((fragment & 0x0000ffff) != 8)
    fprintf(stderr,"Sound card does not support appropriate fragment size");
  sound_enabled = TRUE;
}

int init_sound()
{
  open_sound_device("/dev/dsp");
  configure_sound_device();
  sound_enabled = TRUE;
  load_sounds();
}

void load_sounds()
{
  char filename[200];
  strcpy(filename,"./");
  strcat(filename,SOUND_FILE);
  coll_sndc = 1024; // max size to read
  load_sound(filename, coll_snd, &coll_sndc);
}

#endif
